Index: /trunk/test/list.c
===================================================================
--- /trunk/test/list.c	(revision 150)
+++ /trunk/test/list.c	(revision 151)
@@ -11,8 +11,8 @@
 	int				result = 0;
 	long long int	element = 0;
-	CF_List_Ctx		ctx = NULL;
-	CF_Traverser	trav = NULL;
+	cf_ctx			list = NULL;
+	cf_traverser	trav = NULL;
 
-	result = CF_List_CreateCtx (&ctx);
+	result = CF_List_Create (&list);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -20,10 +20,10 @@
 	for (iter = 0 ; iter < 10 ; iter++)
 	{
-		result = CF_List_Insert (ctx, trav, CF_DIRECTION_BEFORE, (void *)iter);
+		result = CF_List_InsertBefore (list, trav, (void *)iter);
 		if (result < 0)
 			CF_DEBUG_PRINT (stderr, "error %d\n", result);
 	}
 
-	result = CF_List_Front (ctx, &trav);
+	result = CF_List_Front (list, &trav);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -36,15 +36,15 @@
 	}
 
-	result = CF_List_Insert (ctx, trav, CF_DIRECTION_BEFORE, (void *)100);
+	result = CF_List_InsertBefore (list, trav, (void *)100);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
 
-	result = CF_List_Insert (ctx, trav, CF_DIRECTION_AFTER, (void *)200);
+	result = CF_List_InsertAfter (list, trav, (void *)200);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
 
-	for (CF_List_Front (ctx, &trav) ; trav != NULL ; CF_List_Next (&trav))
+	for (CF_List_Front (list, &trav) ; trav != NULL ; CF_List_Next (&trav))
 	{
-		result = CF_List_GetElement (trav, (void **)&element);
+		result = CF_List_Get (trav, (void **)&element);
 		if (result < 0)
 			CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -53,5 +53,5 @@
 	}
 
-	result = CF_List_DestroyCtx (ctx);
+	result = CF_List_Destroy (list);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
Index: /trunk/test/log.c
===================================================================
--- /trunk/test/log.c	(revision 150)
+++ /trunk/test/log.c	(revision 151)
@@ -10,9 +10,10 @@
 #include <stdio.h>
 
-CF_Mutex_Ctx globalMutex;
+#define COUNT	5
 
-#define LOG_MT		1
+cf_ctx	globalLog;
+cf_ctx	globalMutex;
 
-int test_log_mt (void * arg)
+int worker (void * arg)
 {
 	static int cnt = 0;
@@ -32,5 +33,5 @@
 	for (i = 0 ; i < 10000 ; i++)
 	{
-		CF_Log_Write (LOG_MT, "LOG_MT", "[%d] multi-threadedlogging test %d\n", th, i);
+		CF_Log_Write (globalLog, "LOG_MT", "[%d] multi-threadedlogging test %d\n", th, i);
 	}
 
@@ -42,49 +43,32 @@
 int main (void)
 {
-	int				i, j;
-	char			idname[16] = {0x00,};
-	CF_Thread_Ctx	tid[10];
+	int		i, j;
+	cf_ctx	tid[COUNT];
 
 	/* initialize */
-	if (CF_Log_Initialize (10) < 0)
+	if (CF_Log_Create (&globalLog, "log.txt", CF_LOG_NO_BUFFER) < 0)
+		CF_DEBUG_PRINT (stderr, "failed to open log\n");
+
+	for (j = 0 ; j < 10000 ; j++)
 	{
-		fprintf (stderr, "failed to init. log\n");
-		return -1;
-	}
-
-	for (i = 0 ; i < 10 ; i++)
-	{
-		sprintf (idname, "logid%d.txt", i);
-		if (CF_Log_Open (i, idname, CF_LOG_NO_BUFFER) < 0)
-			fprintf (stderr, "failed to open log\n");
-	}
-
-	for (i = 0 ; i < 10 ; i++)
-	{
-		for (j = 0 ; j < 10000 ; j++)
-		{
-			int result = CF_Log_Write (i, "LOG_ID_TEST", "turn %d\n", j); 
-			if (result < 0)
-				fprintf (stderr, "failed to write log %d\n", result);
-		}
-
-		if (CF_Log_Close (i) < 0)
-			fprintf (stderr, "failed to close log\n");
+		int result = CF_Log_Write (globalLog, "LOG_ID_TEST", "turn %d\n", j); 
+		if (result < 0)
+			CF_DEBUG_PRINT (stderr, "failed to write log %d\n", result);
 	}
 
 	/* mt {{{ */
-	if (CF_Log_Open (LOG_MT, "log_mt.txt", CF_LOG_DEFAULT_BUFFER) < 0)
+	if (CF_Log_Create (&globalLog, "log_mt.txt", CF_LOG_NO_BUFFER) < 0)
 		CF_DEBUG_PRINT (stderr, "create log ctx error\n");
 
-	if (CF_Log_SetMT (LOG_MT, CF_TRUE) < 0)
-		CF_DEBUG_PRINT (stderr, "set multi-threading mode error\n");
-
-	if (CF_Mutex_CreateCtx (&globalMutex) < 0) {
+	if (CF_Mutex_Create (&globalMutex) < 0) {
 		// error
 	}
 
-	for (i = 0 ; i < 10 ; i++)
+	if (CF_Log_SetMultiThread (globalLog) < 0)
+		CF_DEBUG_PRINT (stderr, "set multi-threading mode error\n");
+
+	for (i = 0 ; i < COUNT ; i++)
 	{
-		if (CF_Thread_CreateCtx (&tid[i], test_log_mt, &i) < 0)
+		if (CF_Thread_Create (&tid[i], worker, &i) < 0)
 		{
 			CF_DEBUG_PRINT (stderr, "failed to create %dth thread\n", i);
@@ -93,5 +77,5 @@
 	}
 
-	for (i = 0 ; i < 10 ; i++)
+	for (i = 0 ; i < COUNT ; i++)
 	{
 		if (CF_Thread_Start (tid[i]) < 0)
@@ -102,13 +86,16 @@
 	}
 
-	for (i = 0 ; i < 10 ; i++)
+	for (i = 0 ; i < COUNT ; i++)
 	{
 		if (CF_Thread_Join (tid[i]) < 0)
 			CF_DEBUG_PRINT (stderr, "failed to join %dth thread\n", i);
-		if (CF_Thread_DestroyCtx (tid[i]) < 0)
+		if (CF_Thread_Destroy (tid[i]) < 0)
 			CF_DEBUG_PRINT (stderr, "failed to release %dth thread\n", i);
 	}
 
-	if (CF_Mutex_DestoryCtx (globalMutex) < 0) {
+	if (CF_Log_UnsetMultiThread (globalLog) < 0)
+		CF_DEBUG_PRINT (stderr, "set multi-threading mode error\n");
+
+	if (CF_Mutex_Destory (globalMutex) < 0) {
 		// error
 	}
@@ -116,5 +103,5 @@
 
 	/* finalize */
-	CF_Log_Finalize ();
+	CF_Log_Destroy (globalLog);
 
 	return 0;
Index: /trunk/test/queue.c
===================================================================
--- /trunk/test/queue.c	(revision 150)
+++ /trunk/test/queue.c	(revision 151)
@@ -6,4 +6,6 @@
 #include "cf_debug.h"
 
+#define	COUNT	5
+
 int main (void)
 {
@@ -11,15 +13,15 @@
 	int				result = 0;
 	long long int	element = 0;
-	CF_Queue_Ctx	ctx = NULL;
+	cf_ctx			queue = NULL;
 
 	// create
-	result = CF_Queue_CreateCtx (&ctx);
+	result = CF_Queue_Create (&queue);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
 
 	// insert
-	for (iter = 0 ; iter < 10 ; iter++)
+	for (iter = 0 ; iter < COUNT ; iter++)
 	{
-		result = CF_Queue_Put (ctx, (void *)iter);
+		result = CF_Queue_Put (queue, (void *)iter);
 		if (result < 0)
 			CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -27,7 +29,7 @@
 
 	// move next
-	for (iter = 0 ; iter < 10 ; iter++)
+	for (iter = 0 ; iter < COUNT ; iter++)
 	{
-		result = CF_Queue_Front (ctx, (void **)&element);
+		result = CF_Queue_Front (queue, (void **)&element);
 		if (result < 0)
 			CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -35,5 +37,5 @@
 			CF_DEBUG_PRINT (stderr, "front : %4d\n", element);
 
-		result = CF_Queue_Get (ctx, (void **)&element);
+		result = CF_Queue_Get (queue, (void **)&element);
 		if (result < 0)
 			CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -45,5 +47,5 @@
 
 	// destroy
-	result = CF_Queue_DestroyCtx (ctx);
+	result = CF_Queue_Destroy (queue);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
Index: /trunk/test/socket.c
===================================================================
--- /trunk/test/socket.c	(revision 150)
+++ /trunk/test/socket.c	(revision 151)
@@ -8,12 +8,15 @@
 #include <string.h>
 
-#define LOG_SOCKET		0
-#define THREAD_POOL		1
+#define THREAD_POOL		2
 #define PORT			1234
-
-int socket_echo_server (void * arg)
+#define COUNT			2
+
+cf_ctx gLog;
+
+int server_worker (void * arg)
 {
-	int srvsock = *((int *)arg);
-	int clntsock = 0;
+	cf_ctx srvsock = (cf_ctx)arg;
+	cf_ctx clntsock = NULL;
+	int result = 0;
 	int recvd = 0;
 	char buf[1024] = {0x00,};
@@ -21,13 +24,13 @@
 
 	/*------------------------------------------------------------*/
-	clntsock = CF_Socket_Accept (srvsock);
-	if (clntsock < 0)
+	result = CF_Socket_Accept (srvsock, &clntsock);
+	if (result < 0)
 	{
 		CF_DEBUG_PRINT (stderr, "failed to accept on server\n");
 		return -1;
 	}
-	CF_Log_Write (LOG_SOCKET, "SERVER", "accepted\n");
-
-	for (i = 0 ; i < 5 ; i++)
+	CF_Log_Write (gLog, "SERVER", "accepted\n");
+
+	for (i = 0 ; i < COUNT ; i++)
 	{
 		if ((recvd = CF_Socket_Recv (clntsock, buf, sizeof (buf))) < 0)
@@ -36,6 +39,6 @@
 			return -2;
 		}
-		CF_Log_Write (LOG_SOCKET, "SERVER", "recv {%s}\n", buf);
-		CF_DEBUG_PRINT (stderr, "[SERVER] recv {%s}\n", buf);
+		CF_Log_Write (gLog, "SERVER", "recv {%s}\n", buf);
+		CF_DEBUG_PRINT (stderr, "recv {%s}\n", buf);
 
 		if (CF_Socket_Send (clntsock, buf, (size_t)recvd) < 0)
@@ -43,6 +46,6 @@
 			return -3;
 		}
-		CF_Log_Write (LOG_SOCKET, "SERVER", "resp {%s}\n", buf);
-		CF_DEBUG_PRINT (stderr, "[SERVER] resp {%s}\n", buf);
+		CF_Log_Write (gLog, "SERVER", "resp {%s}\n", buf);
+		CF_DEBUG_PRINT (stderr, "resp {%s}\n", buf);
 	}
 
@@ -53,7 +56,8 @@
 }
 
-int socket_echo_client (void * arg)
+int client_worker (void * arg)
 {
-	int sock = 0;
+	cf_ctx sock = NULL;
+	int result = 0;
 	int recvd = 0;
 	char buf[1024] = {0x00,};
@@ -63,21 +67,28 @@
 
 	/*------------------------------------------------------------*/
-	sock = CF_Socket_Connect ("localhost", PORT);
-	if (sock < 0)
+	result = CF_Socket_Create (&sock);
+	if (result < 0)
+	{
+		CF_DEBUG_PRINT (stderr, "failed to create\n");
+		return -1;
+	}
+
+	result = CF_Socket_Connect (sock, "localhost", PORT);
+	if (result < 0)
 	{
 		CF_DEBUG_PRINT (stderr, "failed to connect on client\n");
-		return -1;
-	}
-	CF_Log_Write (LOG_SOCKET, "CLIENT", "connected\n");
-
-	for (i = 0 ; i < 5 ; i++)
+		return -2;
+	}
+	CF_Log_Write (gLog, "CLIENT", "connected\n");
+
+	for (i = 0 ; i < COUNT ; i++)
 	{
 		if (CF_Socket_Send (sock, buf, sizeof (buf)) < 0)
 		{
 			CF_DEBUG_PRINT (stderr, "failed to send on client %d\n", errno);
-			return -2;
-		}
-		CF_Log_Write (LOG_SOCKET, "CLIENT", "sent {%s}\n", buf);
-		CF_DEBUG_PRINT (stderr, "[CLIENT] sent {%s}\n", buf);
+			return -3;
+		}
+		CF_Log_Write (gLog, "CLIENT", "sent {%s}\n", buf);
+		CF_DEBUG_PRINT (stderr, "sent {%s}\n", buf);
 
 		memset (buf, 0x00, sizeof (buf));
@@ -86,8 +97,8 @@
 		{
 			CF_DEBUG_PRINT (stderr, "failed to recv on client\n");
-			return -3;
-		}
-		CF_Log_Write (LOG_SOCKET, "CLIENT", "recv {%s}\n", buf);
-		CF_DEBUG_PRINT (stderr, "[CLIENT] recv {%s}\n", buf);
+			return -4;
+		}
+		CF_Log_Write (gLog, "CLIENT", "recv {%s}\n", buf);
+		CF_DEBUG_PRINT (stderr, "recv {%s}\n", buf);
 	}
 
@@ -100,30 +111,34 @@
 int main ()
 {
-	CF_Thread_Ctx stid[THREAD_POOL];
-	CF_Thread_Ctx ctid[THREAD_POOL];
-
-	int sock = 0;
+	cf_ctx stid[THREAD_POOL];
+	cf_ctx ctid[THREAD_POOL];
+
+	char ip[256] = {0x00,};
+	unsigned short port = 0;
+	cf_ctx sock = 0;
+	int result = 0;
 	int iter = 0;
 
 	/*------------------------------------------------------------*/
-	if (CF_Log_Initialize (1) < 0)
-	{
-		fprintf (stderr, "failed to init. log\n");
+	if (CF_Log_Create (&gLog, "socket.txt", CF_LOG_DEFAULT_BUFFER) < 0)
+		CF_DEBUG_PRINT (stderr, "failed to open log\n");
+
+	CF_Log_Write (gLog, "LOG_MULTITHREAD", "multi-threaded logging test with socket\n");
+
+	if (CF_Socket_Initialize () < 0)
+	{
+		CF_DEBUG_PRINT (stderr, "failed to initialize socket\n");
 		return -1;
 	}
-
-	if (CF_Log_Open (LOG_SOCKET, "socket.txt", CF_LOG_DEFAULT_BUFFER) < 0)
-		CF_DEBUG_PRINT (stderr, "failed to open log\n");
-
-	CF_Log_Write (LOG_SOCKET, "LOG_MULTITHREAD", "multi-threaded logging test with socket\n");
-
-	if (CF_Socket_Initialize () < 0)
-	{
-		CF_DEBUG_PRINT (stderr, "failed to initialize socket\n");
+	CF_Log_Write (gLog, "SOCKET", "socket initialized\n");
+
+	result = CF_Socket_Create (&sock);
+	if (result < 0)
+	{
+		CF_DEBUG_PRINT (stderr, "failed to create\n");
 		return -2;
 	}
-	CF_Log_Write (LOG_SOCKET, "SOCKET", "socket initialized\n");
-
-	sock = CF_Socket_Server (PORT, 5);
+
+	result = CF_Socket_Server (sock, PORT, 5);
 	if (sock < 0)
 	{
@@ -131,24 +146,28 @@
 		return -3;
 	}
-	CF_Log_Write (LOG_SOCKET, "SOCKET", "socket ready\n");
-
-	for (iter = 0 ; iter < THREAD_POOL ; iter++)
-	{
-		if (CF_Thread_CreateCtx (&stid[iter], socket_echo_server, &sock) < 0)
+	CF_Socket_GetIP (sock, ip);
+	CF_Socket_GetPort (sock, &port);
+	CF_Log_Write (gLog, "SOCKET", "socket ready [%s:%d]\n", ip, port);
+	CF_DEBUG_PRINT (stderr, "socket ready [%s:%d]\n", ip, port);
+ 
+
+	for (iter = 0 ; iter < THREAD_POOL ; iter++)
+	{
+		if (CF_Thread_Create (&stid[iter], server_worker, sock) < 0)
 		{
 			CF_DEBUG_PRINT (stderr, "failed to create %dth thread\n", iter);
 			return -4;
 		}
-		CF_Log_Write (LOG_SOCKET, "SOCKET", "create server thread-%d\n", iter);
-	}
-
-	for (iter = 0 ; iter < THREAD_POOL ; iter++)
-	{
-		if (CF_Thread_CreateCtx (&ctid[iter], socket_echo_client, &sock) < 0)
+		CF_Log_Write (gLog, "SOCKET", "create server thread-%d\n", iter);
+	}
+
+	for (iter = 0 ; iter < THREAD_POOL ; iter++)
+	{
+		if (CF_Thread_Create (&ctid[iter], client_worker, &sock) < 0)
 		{
 			CF_DEBUG_PRINT (stderr, "failed to create %dth thread\n", iter);
 			return -5;
 		}
-		CF_Log_Write (LOG_SOCKET, "SOCKET", "create client thread-%d\n", iter);
+		CF_Log_Write (gLog, "SOCKET", "create client thread-%d\n", iter);
 	}
 
@@ -174,10 +193,10 @@
 	{
 		CF_Thread_Join (ctid[iter]);
-		CF_Thread_DestroyCtx (ctid[iter]);
+		CF_Thread_Destroy (ctid[iter]);
 
 		CF_Thread_Join (stid[iter]);
-		CF_Thread_DestroyCtx (stid[iter]);
-
-		CF_Log_Write (LOG_SOCKET, "SOCKET", "join server thread-%d\n", iter);
+		CF_Thread_Destroy (stid[iter]);
+
+		CF_Log_Write (gLog, "SOCKET", "join server thread-%d\n", iter);
 	}
 
@@ -186,7 +205,5 @@
 	CF_Socket_Finalize ();
 
-	CF_Log_Close (LOG_SOCKET);
-
-	CF_Log_Finalize ();
+	CF_Log_Destroy (gLog);
 	/*------------------------------------------------------------*/
 
Index: /trunk/test/stack.c
===================================================================
--- /trunk/test/stack.c	(revision 150)
+++ /trunk/test/stack.c	(revision 151)
@@ -6,4 +6,6 @@
 #include "cf_debug.h"
 
+#define	COUNT	5
+
 int main (void)
 {
@@ -11,15 +13,15 @@
 	int				result = 0;
 	long long int	element = 0;
-	CF_Stack_Ctx	ctx = NULL;
+	cf_ctx			stack = NULL;
 
 	// create
-	result = CF_Stack_CreateCtx (&ctx);
+	result = CF_Stack_Create (&stack);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
 
 	// insert
-	for (iter = 0 ; iter < 10 ; iter++)
+	for (iter = 0 ; iter < COUNT ; iter++)
 	{
-		result = CF_Stack_Push (ctx, (void *)iter);
+		result = CF_Stack_Push (stack, (void *)iter);
 		if (result < 0)
 			CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -27,7 +29,7 @@
 
 	// move next
-	for (iter = 0 ; iter < 10 ; iter++)
+	for (iter = 0 ; iter < COUNT ; iter++)
 	{
-		result = CF_Stack_Top (ctx, (void **)&element);
+		result = CF_Stack_Top (stack, (void **)&element);
 		if (result < 0)
 			CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -35,5 +37,5 @@
 			CF_DEBUG_PRINT (stderr, "top   : %4d\n", element);
 
-		result = CF_Stack_Pop (ctx, (void **)&element);
+		result = CF_Stack_Pop (stack, (void **)&element);
 		if (result < 0)
 			CF_DEBUG_PRINT (stderr, "error %d\n", result);
@@ -45,5 +47,5 @@
 
 	// destroy
-	result = CF_Stack_DestroyCtx (ctx);
+	result = CF_Stack_Destroy (stack);
 	if (result < 0)
 		CF_DEBUG_PRINT (stderr, "error %d\n", result);
Index: /trunk/test/thread.c
===================================================================
--- /trunk/test/thread.c	(revision 150)
+++ /trunk/test/thread.c	(revision 151)
@@ -8,7 +8,10 @@
 #include <stdio.h>
 
-CF_Mutex_Ctx globalMutex;
+#define	COUNT	5
 
-int worker (void * arg) {
+cf_ctx globalMutex;
+
+int worker (void * arg)
+{
 	if (CF_Mutex_Lock (globalMutex) < 0) { // for critical section
 		// error
@@ -24,19 +27,20 @@
 }
 
-int main (void) {
-	CF_Thread_Ctx tid[10];
-	int i = 0;
+int main (void)
+{
+	cf_ctx	tid[COUNT];
+	int		i = 0;
 
-	if (CF_Mutex_CreateCtx (&globalMutex) < 0) {
+	if (CF_Mutex_Create (&globalMutex) < 0) {
 		// error
 	}
 
-	for (i = 0 ; i < 10 ; i++) {
-		if (CF_Thread_CreateCtx (&tid[i], worker, NULL) < 0) {
+	for (i = 0 ; i < COUNT ; i++) {
+		if (CF_Thread_Create (&tid[i], worker, NULL) < 0) {
 			// error
 		}
 	}
 
-	for (i = 0 ; i < 10 ; i++) {
+	for (i = 0 ; i < COUNT ; i++) {
 		if (CF_Thread_Start (tid[i]) < 0) {
 			// error
@@ -44,5 +48,5 @@
 	}
 
-	for (i = 0 ; i < 10 ; i++) {
+	for (i = 0 ; i < COUNT ; i++) {
 		if (CF_Thread_Join (tid[i]) < 0) { // block
 			// error
@@ -50,11 +54,11 @@
 	}
 
-	for (i = 0 ; i < 10 ; i++) {
-		if (CF_Thread_DestroyCtx (tid[i]) < 0) {
+	for (i = 0 ; i < COUNT ; i++) {
+		if (CF_Thread_Destroy (tid[i]) < 0) {
 			// error
 		}
 	}
 
-	if (CF_Mutex_DestoryCtx (globalMutex) < 0) {
+	if (CF_Mutex_Destory (globalMutex) < 0) {
 		// error
 	}
Index: /trunk/test/util.c
===================================================================
--- /trunk/test/util.c	(revision 151)
+++ /trunk/test/util.c	(revision 151)
@@ -0,0 +1,21 @@
+/**
+ * @file	util.c
+ * @author	myusgun <myusgun@gmail.com>
+ */
+#include "cf_util.h"
+#include <stdio.h>
+
+int main (void)
+{
+	CF_UTIL_DATETIME dt;
+
+	char buf[CF_UTIL_DATETIME_LENGTH + 1] = {0x00,};
+
+	CF_Util_GetCurrentTime (&dt);
+
+	CF_Util_GetTimeString (&dt, buf);
+
+	printf ("current time : %s\n", buf);
+
+	return 0;
+}
